#include <bits/stdc++.h>
#define ll long long
using namespace std;
ll INF = 1e9;
ll cnt = 0;
void bfs(ll s,vector <vector<ll>> &g, vector <ll> &dist){
    dist[s] = 0;
    queue <ll> q;
    q.push(s);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(auto to:g[v]){
            if(dist[to] > dist[v] + 1){
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }
}
int main() {
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    ll n,m,k;
    cin>>n>>m>>k;
    vector <vector <ll>> g(n);
    for(int i=0; i<m; i++){
        ll a,b;
        cin>>a>>b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    set <ll> ans;
    while(k--) {
        ll p, h;
        cin >> p >> h;
        p--;
        vector<ll> dist(n, INF);
        bfs(p, g, dist);
        for (int i=0; i<dist.size();i++) {
            if(dist[i]<=h){
                if(!ans.count(i+1) && ans.size()<=n) {
                    cnt++;
                }
                ans.insert(i+1);
            }
        }
        if(ans.size()==n){
            break;
        }
    }
    if(!cnt){
        cout<<" ";
    }
    else {
        cout << cnt << '\n';
        for (auto to: ans) {
            cout << to << ' ';
        }
    }
}